;Configuration
global $config_directory = @ScriptDir & "\Test\"
global $letter_of_virtual_drive = "e:\"
global $test = 0
;End Configuration

If $test <> 0 Then debug("Test Mode!")

If StringRight($config_directory,1) <> "\" Then $config_directory = $config_directory & "\"
If StringRight($letter_of_virtual_drive,2) <> ":\" Then $letter_of_virtual_drive = $letter_of_virtual_drive & ":\"

global $file_duplicated
global $static_duplicated_line = 0
global $filelist_content
global $renamelist
global $script_file
global $saved_space = 0


$file_duplicated = FileOpen("duplicated.txt",0)
If $file_duplicated == -1 Then fatal_error("Error creating opening duplicated file.")
$renamelist = FileOpen("rename.txt",2)
If $renamelist == -1 Then fatal_error("Error creating renamelist file.")
$script_file = FileOpen("script.txt",2)
If $script_file == -1 Then fatal_error("Error creating script file.")

read_filelist("filelist.txt")

;Parent
For $i = 1 To 999999
	$entry = pop_line_to_array()
	If $entry == -1 Then ExitLoop
	$parent_number = $entry[2]
	$newname = rename($entry[1],$entry[0])
	add_script_parent($newname)
	replace_filelist($entry[1],$entry[0],$newname)
	;Child
	For $j = 1 To 999999
		$entry = pop_line_to_array()
		If $entry == -1 Then ExitLoop
		$child_number = $entry[2]
		If $child_number <> $parent_number Then
			undo_pop_line()
			ExitLoop
		EndIf
		file_compute_size($entry[1],$entry[0])
		clear_file($entry[1],$entry[0])
		$newname = rename($entry[1],$entry[0])
		add_script_child($newname)
		replace_filelist($entry[1],$entry[0],$newname)
	Next
Next

FileClose($file_duplicated)
FileClose($renamelist)

save_new_filelist("new_filelist.txt")
normal_exit()

Func normal_exit()
	local $megabytes = $saved_space / (1024*1024)
	MsgBox(64,"Finish",StringFormat("Total space saved: %d bytes\n~%.1fmb",$saved_space,$megabytes))
EndFunc

Func save_new_filelist($new_filelist_name)
	local $file = FileOpen($new_filelist_name,2)
	local $check = FileWrite ($file,$filelist_content)
	If $check == 0 Then fatal_error("Error saving final filelist.")
	FileClose($file)
EndFunc

Func debug_exit($message)
	debug($message)
	Exit
EndFunc

Func replace_filelist($path,$old_name,$new_name)
	If StringRight($new_name,1) == "." Then $new_name = StringTrimRight($new_name,1)
	local $pos = StringInStr($path,$config_directory)
	If $pos == 0 Then
		fatal_error("Error adjusting file list?" & @CRLF & "Debug information: " & @CRLF & "$path $old_name $new_name" & @CRLF & "-" & $path & "- -" & $old_name & "- -" & $new_name & "-" & @CRLF & "$path $config_directory" & @CRLF & "-" & $path & "- -" & $config_directory & "-")
	EndIf
	;Moves pos to where partial_path starts
	$pos = $pos + StringLen($config_directory)
	local $chars_to_get = StringLen($path) - $pos + 1
	local $partial_path = StringRight($path,$chars_to_get)
	local $new_path = $letter_of_virtual_drive & $partial_path & $new_name & @CRLF
	$partial_path = $letter_of_virtual_drive & $partial_path & $old_name & @CRLF
	$filelist_content = StringReplace($filelist_content,$partial_path,$new_path)
	If @extended <> 1 Then fatal_error("Error replacing characters on filelist?")
EndFunc

Func file_compute_size($path,$filename)
	local $size = FileGetSize ($path & $filename)
	If @error == 1 Then fatal_error("Unable to determine size of:" & @CRLF & $path & $filename)
	$saved_space = $saved_space + $size
EndFunc

Func add_script_child($newname)
	FileWriteLine($script_file,$newname & ".")
EndFunc

Func add_script_parent($newname)
	;Numbers need to be adjusted manually later.
	FileWriteLine($script_file,"#")
	FileWriteLine($script_file,$newname & ".")
EndFunc

Func clear_file($path,$filename)
	If $test <> 0 Then Return
	local $file = FileOpen($path & $filename,2)
	local $check = FileClose($file)
	If $check  == 0 Then fatal_error("Error erasing file:" & @CRLF & $path & $filename)
EndFunc


Func undo_pop_line()
	$static_duplicated_line = $static_duplicated_line - 1
EndFunc

;Error => returns -1
Func pop_line_to_array()
	local $line = FileReadLine($file_duplicated,$static_duplicated_line + 1)
	If $line == "" Then return -1
	$static_duplicated_line = $static_duplicated_line + 1
	;0 = Name, 1 = path, 2 = order
	local $return[3]
	local $tab_pos = StringInStr($line,@TAB,2,1)
	If $tab_pos == 0 Then fatal_error("File out of specifications? @TAB not found.")
	$return[0] = StringLeft($line,$tab_pos - 1)
	local $tab_pos2 = StringInStr ($line,@TAB,2,2)
	If $tab_pos2 == 0 Then fatal_error("File out of specifications?")
	$return[1] = StringMid ($line,$tab_pos + 1,$tab_pos2 - $tab_pos - 1)
	$tab_pos = StringInStr($line,@TAB,2,3)
	If $tab_pos == 0 Then fatal_error("File out of specifications?")
	$return[2] = StringTrimRight(StringMid($line,$tab_pos + 1),1)
	;Convert to number seems to solve some problems
	$return[2] = Number($return[2])
	return $return
EndFunc

Func fatal_error($message)
	MsgBox(16,"Fatal error",$message)
	Exit
EndFunc

Func debug($message)
	MsgBox(0,"Debug",$message)
EndFunc

;Also correct filenames without extension
Func read_filelist($filename)
	$filelist_content = ""
	local $file = FileOpen ($filename,0)
	If $file == -1 Then fatal_error("Error during the open of filelist.")
	local $i, $line
	For $i = 1 To 999999
		$line = FileReadLine($file,$i)
		If $line == "" Then ExitLoop
		$filelist_content = $filelist_content & $line & @CRLF
	Next
	FileClose($file)
	$filelist_content = StringReplace($filelist_content,"." & @CRLF,@CRLF)
	If StringRight($filelist_content,2) <> @CRLF Then $filelist_content = $filelist_content & @CRLF
	;Correction 1
	Do
		$filelist_content = StringReplace ($filelist_content,@TAB & @TAB,@TAB)
	Until @extended == 0
EndFunc

Func generate_random_name($number_of_letters)
	local $i
	local $return = ""
	local $number
	For $i = 1 To $number_of_letters
		$number = Random(65,100,1)
		;If it's a number
		If $number > 90 Then $number = $number - 43
		$return = $return & Chr($number)
	Next
	Return $return
EndFunc

;Also adds an entry to the rename file list
Func rename($path,$filename)
	local $newname 
	local $temp
	$temp = StringInStr($filename,".")
	If $temp == 0 Then
		$newname = generate_random_name(StringLen($filename))
		FileWriteLine($renamelist,$newname & ".")
		FileWriteLine ($renamelist,$filename & ".")
	Else
		$newname = generate_random_name(StringLen($filename) - 1)
		FileWriteLine($renamelist,$newname & ".")
		FileWriteLine($renamelist,$filename)
	EndIf
	If $test <> 0 Then Return $newname
	local $check = FileMove($path & $filename,$path & $newname)
	If $check == 0 Then fatal_error("Error renaming:" & @CRLF & $path & $filename)
	Return $newname
EndFunc